/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Author;
import io.swagger.client.model.Category;
import io.swagger.client.model.CustomArticleField;
import io.swagger.client.model.FundingInformation;
import io.swagger.client.model.GroupEmbargoOptions;
import io.swagger.client.model.License;
import io.swagger.client.model.ProjectArticle;
import io.swagger.client.model.PublicFile;
import io.swagger.client.model.RelatedMaterial;
import io.swagger.client.model.Timeline;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ArticleComplete
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ArticleComplete extends ProjectArticle {
  @SerializedName("citation")
  private String citation = null;

  @SerializedName("confidential_reason")
  private String confidentialReason = null;

  @SerializedName("is_confidential")
  private Boolean isConfidential = null;

  @SerializedName("size")
  private Long size = null;

  @SerializedName("funding")
  private String funding = null;

  @SerializedName("funding_list")
  private List<FundingInformation> fundingList = null;

  @SerializedName("tags")
  private List<String> tags = null;

  @SerializedName("version")
  private Long version = null;

  @SerializedName("is_active")
  private Boolean isActive = null;

  @SerializedName("is_metadata_record")
  private Boolean isMetadataRecord = null;

  @SerializedName("metadata_reason")
  private String metadataReason = null;

  @SerializedName("status")
  private String status = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("is_embargoed")
  private Boolean isEmbargoed = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  @SerializedName("created_date")
  private String createdDate = null;

  @SerializedName("has_linked_file")
  private Boolean hasLinkedFile = null;

  @SerializedName("categories")
  private List<Category> categories = null;

  @SerializedName("license")
  private License license = null;

  @SerializedName("embargo_title")
  private String embargoTitle = null;

  @SerializedName("embargo_reason")
  private String embargoReason = null;

  @SerializedName("references")
  private List<String> references = null;

  @SerializedName("related_materials")
  private List<RelatedMaterial> relatedMaterials = null;

  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("handle")
  private String handle = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("url_public_html")
  private String urlPublicHtml = null;

  @SerializedName("url_public_api")
  private String urlPublicApi = null;

  @SerializedName("url_private_html")
  private String urlPrivateHtml = null;

  @SerializedName("url_private_api")
  private String urlPrivateApi = null;

  @SerializedName("timeline")
  private Timeline timeline = null;

  @SerializedName("thumb")
  private String thumb = null;

  @SerializedName("defined_type")
  private Long definedType = null;

  @SerializedName("defined_type_name")
  private String definedTypeName = null;

  @SerializedName("figshare_url")
  private String figshareUrl = null;

  @SerializedName("download_disabled")
  private Boolean downloadDisabled = null;

  @SerializedName("files")
  private List<PublicFile> files = new ArrayList<PublicFile>();

  @SerializedName("authors")
  private List<Author> authors = new ArrayList<Author>();

  @SerializedName("custom_fields")
  private List<CustomArticleField> customFields = new ArrayList<CustomArticleField>();

  @SerializedName("embargo_options")
  private List<GroupEmbargoOptions> embargoOptions = new ArrayList<GroupEmbargoOptions>();

  public ArticleComplete citation(String citation) {
    this.citation = citation;
    return this;
  }

   /**
   * Article citation
   * @return citation
  **/
  @ApiModelProperty(example = "lilliput, figshare admin (2017): first project item. figshare.    Retrieved: 14 01, May 22, 2017 (GMT)", value = "Article citation")
  public String getCitation() {
    return citation;
  }

  public void setCitation(String citation) {
    this.citation = citation;
  }

  public ArticleComplete confidentialReason(String confidentialReason) {
    this.confidentialReason = confidentialReason;
    return this;
  }

   /**
   * Confidentiality reason
   * @return confidentialReason
  **/
  @ApiModelProperty(example = "none", value = "Confidentiality reason")
  public String getConfidentialReason() {
    return confidentialReason;
  }

  public void setConfidentialReason(String confidentialReason) {
    this.confidentialReason = confidentialReason;
  }

  public ArticleComplete isConfidential(Boolean isConfidential) {
    this.isConfidential = isConfidential;
    return this;
  }

   /**
   * Article Confidentiality
   * @return isConfidential
  **/
  @ApiModelProperty(example = "true", value = "Article Confidentiality")
  public Boolean isIsConfidential() {
    return isConfidential;
  }

  public void setIsConfidential(Boolean isConfidential) {
    this.isConfidential = isConfidential;
  }

  public ArticleComplete size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * Article size
   * @return size
  **/
  @ApiModelProperty(example = "69939", value = "Article size")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public ArticleComplete funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Article funding
   * @return funding
  **/
  @ApiModelProperty(example = "none", value = "Article funding")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ArticleComplete fundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ArticleComplete addFundingListItem(FundingInformation fundingListItem) {
    if (this.fundingList == null) {
      this.fundingList = new ArrayList<FundingInformation>();
    }
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Full Article funding information
   * @return fundingList
  **/
  @ApiModelProperty(value = "Full Article funding information")
  public List<FundingInformation> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
  }

  public ArticleComplete tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public ArticleComplete addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * List of article tags
   * @return tags
  **/
  @ApiModelProperty(example = "[\"t1\",\"t2\",\"t3\"]", value = "List of article tags")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public ArticleComplete version(Long version) {
    this.version = version;
    return this;
  }

   /**
   * Article version
   * @return version
  **/
  @ApiModelProperty(example = "1", value = "Article version")
  public Long getVersion() {
    return version;
  }

  public void setVersion(Long version) {
    this.version = version;
  }

  public ArticleComplete isActive(Boolean isActive) {
    this.isActive = isActive;
    return this;
  }

   /**
   * True if article is active
   * @return isActive
  **/
  @ApiModelProperty(example = "true", value = "True if article is active")
  public Boolean isIsActive() {
    return isActive;
  }

  public void setIsActive(Boolean isActive) {
    this.isActive = isActive;
  }

  public ArticleComplete isMetadataRecord(Boolean isMetadataRecord) {
    this.isMetadataRecord = isMetadataRecord;
    return this;
  }

   /**
   * True if article has no files
   * @return isMetadataRecord
  **/
  @ApiModelProperty(example = "false", value = "True if article has no files")
  public Boolean isIsMetadataRecord() {
    return isMetadataRecord;
  }

  public void setIsMetadataRecord(Boolean isMetadataRecord) {
    this.isMetadataRecord = isMetadataRecord;
  }

  public ArticleComplete metadataReason(String metadataReason) {
    this.metadataReason = metadataReason;
    return this;
  }

   /**
   * Article metadata reason
   * @return metadataReason
  **/
  @ApiModelProperty(example = "hosted somewhere else", value = "Article metadata reason")
  public String getMetadataReason() {
    return metadataReason;
  }

  public void setMetadataReason(String metadataReason) {
    this.metadataReason = metadataReason;
  }

  public ArticleComplete status(String status) {
    this.status = status;
    return this;
  }

   /**
   * Article status
   * @return status
  **/
  @ApiModelProperty(example = "public", value = "Article status")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public ArticleComplete description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Article description
   * @return description
  **/
  @ApiModelProperty(example = "article description", value = "Article description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ArticleComplete isEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
    return this;
  }

   /**
   * True if article is embargoed
   * @return isEmbargoed
  **/
  @ApiModelProperty(example = "true", value = "True if article is embargoed")
  public Boolean isIsEmbargoed() {
    return isEmbargoed;
  }

  public void setIsEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
  }

  public ArticleComplete isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * True if article is published
   * @return isPublic
  **/
  @ApiModelProperty(example = "true", value = "True if article is published")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }

  public ArticleComplete createdDate(String createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * Date when article was created
   * @return createdDate
  **/
  @ApiModelProperty(example = "2017-05-18T11:49:03Z", value = "Date when article was created")
  public String getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(String createdDate) {
    this.createdDate = createdDate;
  }

  public ArticleComplete hasLinkedFile(Boolean hasLinkedFile) {
    this.hasLinkedFile = hasLinkedFile;
    return this;
  }

   /**
   * True if any files are linked to the article
   * @return hasLinkedFile
  **/
  @ApiModelProperty(example = "true", value = "True if any files are linked to the article")
  public Boolean isHasLinkedFile() {
    return hasLinkedFile;
  }

  public void setHasLinkedFile(Boolean hasLinkedFile) {
    this.hasLinkedFile = hasLinkedFile;
  }

  public ArticleComplete categories(List<Category> categories) {
    this.categories = categories;
    return this;
  }

  public ArticleComplete addCategoriesItem(Category categoriesItem) {
    if (this.categories == null) {
      this.categories = new ArrayList<Category>();
    }
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * List of categories selected for the article
   * @return categories
  **/
  @ApiModelProperty(value = "List of categories selected for the article")
  public List<Category> getCategories() {
    return categories;
  }

  public void setCategories(List<Category> categories) {
    this.categories = categories;
  }

  public ArticleComplete license(License license) {
    this.license = license;
    return this;
  }

   /**
   * Article selected license
   * @return license
  **/
  @ApiModelProperty(value = "Article selected license")
  public License getLicense() {
    return license;
  }

  public void setLicense(License license) {
    this.license = license;
  }

  public ArticleComplete embargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
    return this;
  }

   /**
   * Title for embargo
   * @return embargoTitle
  **/
  @ApiModelProperty(example = "File(s) under embargo", value = "Title for embargo")
  public String getEmbargoTitle() {
    return embargoTitle;
  }

  public void setEmbargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
  }

  public ArticleComplete embargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
    return this;
  }

   /**
   * Reason for embargo
   * @return embargoReason
  **/
  @ApiModelProperty(example = "not complete", value = "Reason for embargo")
  public String getEmbargoReason() {
    return embargoReason;
  }

  public void setEmbargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
  }

  public ArticleComplete references(List<String> references) {
    this.references = references;
    return this;
  }

  public ArticleComplete addReferencesItem(String referencesItem) {
    if (this.references == null) {
      this.references = new ArrayList<String>();
    }
    this.references.add(referencesItem);
    return this;
  }

   /**
   * List of references
   * @return references
  **/
  @ApiModelProperty(example = "[\"http://figshare.com\",\"http://figshare.com/api\"]", value = "List of references")
  public List<String> getReferences() {
    return references;
  }

  public void setReferences(List<String> references) {
    this.references = references;
  }

  public ArticleComplete relatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
    return this;
  }

  public ArticleComplete addRelatedMaterialsItem(RelatedMaterial relatedMaterialsItem) {
    if (this.relatedMaterials == null) {
      this.relatedMaterials = new ArrayList<RelatedMaterial>();
    }
    this.relatedMaterials.add(relatedMaterialsItem);
    return this;
  }

   /**
   * List of related materials; supersedes references and resource DOI/title.
   * @return relatedMaterials
  **/
  @ApiModelProperty(example = "[{\"id\":10432,\"identifier\":\"10.6084/m9.figshare.1407024\",\"identifier_type\":\"DOI\",\"relation\":\"IsSupplementTo\",\"title\":\"Figshare for institutions brochure\",\"is_linkout\":false}]", value = "List of related materials; supersedes references and resource DOI/title.")
  public List<RelatedMaterial> getRelatedMaterials() {
    return relatedMaterials;
  }

  public void setRelatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
  }

  public ArticleComplete id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Unique identifier for article
   * @return id
  **/
  @ApiModelProperty(example = "1434614", required = true, value = "Unique identifier for article")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ArticleComplete title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Title of article
   * @return title
  **/
  @ApiModelProperty(example = "Test article title", required = true, value = "Title of article")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ArticleComplete doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * DOI
   * @return doi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1434614", required = true, value = "DOI")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public ArticleComplete handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Handle
   * @return handle
  **/
  @ApiModelProperty(example = "111184/figshare.1234", required = true, value = "Handle")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public ArticleComplete url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint for article
   * @return url
  **/
  @ApiModelProperty(example = "http://api.figshare.com/articles/1434614", required = true, value = "Api endpoint for article")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ArticleComplete urlPublicHtml(String urlPublicHtml) {
    this.urlPublicHtml = urlPublicHtml;
    return this;
  }

   /**
   * Public site endpoint for article
   * @return urlPublicHtml
  **/
  @ApiModelProperty(example = "https://figshare.com/articles/media/Test_article_title/1434614", required = true, value = "Public site endpoint for article")
  public String getUrlPublicHtml() {
    return urlPublicHtml;
  }

  public void setUrlPublicHtml(String urlPublicHtml) {
    this.urlPublicHtml = urlPublicHtml;
  }

  public ArticleComplete urlPublicApi(String urlPublicApi) {
    this.urlPublicApi = urlPublicApi;
    return this;
  }

   /**
   * Public Api endpoint for article
   * @return urlPublicApi
  **/
  @ApiModelProperty(example = "https://api.figshare.com/articles/1434614", required = true, value = "Public Api endpoint for article")
  public String getUrlPublicApi() {
    return urlPublicApi;
  }

  public void setUrlPublicApi(String urlPublicApi) {
    this.urlPublicApi = urlPublicApi;
  }

  public ArticleComplete urlPrivateHtml(String urlPrivateHtml) {
    this.urlPrivateHtml = urlPrivateHtml;
    return this;
  }

   /**
   * Private site endpoint for article
   * @return urlPrivateHtml
  **/
  @ApiModelProperty(example = "https://figshare.com/account/articles/1434614", required = true, value = "Private site endpoint for article")
  public String getUrlPrivateHtml() {
    return urlPrivateHtml;
  }

  public void setUrlPrivateHtml(String urlPrivateHtml) {
    this.urlPrivateHtml = urlPrivateHtml;
  }

  public ArticleComplete urlPrivateApi(String urlPrivateApi) {
    this.urlPrivateApi = urlPrivateApi;
    return this;
  }

   /**
   * Private Api endpoint for article
   * @return urlPrivateApi
  **/
  @ApiModelProperty(example = "https://api.figshare.com/account/articles/1434614", required = true, value = "Private Api endpoint for article")
  public String getUrlPrivateApi() {
    return urlPrivateApi;
  }

  public void setUrlPrivateApi(String urlPrivateApi) {
    this.urlPrivateApi = urlPrivateApi;
  }

  public ArticleComplete timeline(Timeline timeline) {
    this.timeline = timeline;
    return this;
  }

   /**
   * Various timeline dates
   * @return timeline
  **/
  @ApiModelProperty(required = true, value = "Various timeline dates")
  public Timeline getTimeline() {
    return timeline;
  }

  public void setTimeline(Timeline timeline) {
    this.timeline = timeline;
  }

  public ArticleComplete thumb(String thumb) {
    this.thumb = thumb;
    return this;
  }

   /**
   * Thumbnail image
   * @return thumb
  **/
  @ApiModelProperty(example = "https://ndownloader.figshare.com/files/123456789/preview/12345678/thumb.png", required = true, value = "Thumbnail image")
  public String getThumb() {
    return thumb;
  }

  public void setThumb(String thumb) {
    this.thumb = thumb;
  }

  public ArticleComplete definedType(Long definedType) {
    this.definedType = definedType;
    return this;
  }

   /**
   * Type of article identifier
   * @return definedType
  **/
  @ApiModelProperty(example = "3", required = true, value = "Type of article identifier")
  public Long getDefinedType() {
    return definedType;
  }

  public void setDefinedType(Long definedType) {
    this.definedType = definedType;
  }

  public ArticleComplete definedTypeName(String definedTypeName) {
    this.definedTypeName = definedTypeName;
    return this;
  }

   /**
   * Name of the article type identifier
   * @return definedTypeName
  **/
  @ApiModelProperty(example = "media", required = true, value = "Name of the article type identifier")
  public String getDefinedTypeName() {
    return definedTypeName;
  }

  public void setDefinedTypeName(String definedTypeName) {
    this.definedTypeName = definedTypeName;
  }

  public ArticleComplete figshareUrl(String figshareUrl) {
    this.figshareUrl = figshareUrl;
    return this;
  }

   /**
   * Article public url
   * @return figshareUrl
  **/
  @ApiModelProperty(example = "http://figshare.com/articles/media/article_name/2000005", required = true, value = "Article public url")
  public String getFigshareUrl() {
    return figshareUrl;
  }

  public void setFigshareUrl(String figshareUrl) {
    this.figshareUrl = figshareUrl;
  }

  public ArticleComplete downloadDisabled(Boolean downloadDisabled) {
    this.downloadDisabled = downloadDisabled;
    return this;
  }

   /**
   * If true, downloading of files for this article is disabled
   * @return downloadDisabled
  **/
  @ApiModelProperty(example = "false", required = true, value = "If true, downloading of files for this article is disabled")
  public Boolean isDownloadDisabled() {
    return downloadDisabled;
  }

  public void setDownloadDisabled(Boolean downloadDisabled) {
    this.downloadDisabled = downloadDisabled;
  }

  public ArticleComplete files(List<PublicFile> files) {
    this.files = files;
    return this;
  }

  public ArticleComplete addFilesItem(PublicFile filesItem) {
    this.files.add(filesItem);
    return this;
  }

   /**
   * List of article files
   * @return files
  **/
  @ApiModelProperty(required = true, value = "List of article files")
  public List<PublicFile> getFiles() {
    return files;
  }

  public void setFiles(List<PublicFile> files) {
    this.files = files;
  }

  public ArticleComplete authors(List<Author> authors) {
    this.authors = authors;
    return this;
  }

  public ArticleComplete addAuthorsItem(Author authorsItem) {
    this.authors.add(authorsItem);
    return this;
  }

   /**
   * List of article authors
   * @return authors
  **/
  @ApiModelProperty(required = true, value = "List of article authors")
  public List<Author> getAuthors() {
    return authors;
  }

  public void setAuthors(List<Author> authors) {
    this.authors = authors;
  }

  public ArticleComplete customFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
    return this;
  }

  public ArticleComplete addCustomFieldsItem(CustomArticleField customFieldsItem) {
    this.customFields.add(customFieldsItem);
    return this;
  }

   /**
   * List of custom fields values
   * @return customFields
  **/
  @ApiModelProperty(required = true, value = "List of custom fields values")
  public List<CustomArticleField> getCustomFields() {
    return customFields;
  }

  public void setCustomFields(List<CustomArticleField> customFields) {
    this.customFields = customFields;
  }

  public ArticleComplete embargoOptions(List<GroupEmbargoOptions> embargoOptions) {
    this.embargoOptions = embargoOptions;
    return this;
  }

  public ArticleComplete addEmbargoOptionsItem(GroupEmbargoOptions embargoOptionsItem) {
    this.embargoOptions.add(embargoOptionsItem);
    return this;
  }

   /**
   * List of embargo options
   * @return embargoOptions
  **/
  @ApiModelProperty(required = true, value = "List of embargo options")
  public List<GroupEmbargoOptions> getEmbargoOptions() {
    return embargoOptions;
  }

  public void setEmbargoOptions(List<GroupEmbargoOptions> embargoOptions) {
    this.embargoOptions = embargoOptions;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ArticleComplete articleComplete = (ArticleComplete) o;
    return Objects.equals(this.citation, articleComplete.citation) &&
        Objects.equals(this.confidentialReason, articleComplete.confidentialReason) &&
        Objects.equals(this.isConfidential, articleComplete.isConfidential) &&
        Objects.equals(this.size, articleComplete.size) &&
        Objects.equals(this.funding, articleComplete.funding) &&
        Objects.equals(this.fundingList, articleComplete.fundingList) &&
        Objects.equals(this.tags, articleComplete.tags) &&
        Objects.equals(this.version, articleComplete.version) &&
        Objects.equals(this.isActive, articleComplete.isActive) &&
        Objects.equals(this.isMetadataRecord, articleComplete.isMetadataRecord) &&
        Objects.equals(this.metadataReason, articleComplete.metadataReason) &&
        Objects.equals(this.status, articleComplete.status) &&
        Objects.equals(this.description, articleComplete.description) &&
        Objects.equals(this.isEmbargoed, articleComplete.isEmbargoed) &&
        Objects.equals(this.isPublic, articleComplete.isPublic) &&
        Objects.equals(this.createdDate, articleComplete.createdDate) &&
        Objects.equals(this.hasLinkedFile, articleComplete.hasLinkedFile) &&
        Objects.equals(this.categories, articleComplete.categories) &&
        Objects.equals(this.license, articleComplete.license) &&
        Objects.equals(this.embargoTitle, articleComplete.embargoTitle) &&
        Objects.equals(this.embargoReason, articleComplete.embargoReason) &&
        Objects.equals(this.references, articleComplete.references) &&
        Objects.equals(this.relatedMaterials, articleComplete.relatedMaterials) &&
        Objects.equals(this.id, articleComplete.id) &&
        Objects.equals(this.title, articleComplete.title) &&
        Objects.equals(this.doi, articleComplete.doi) &&
        Objects.equals(this.handle, articleComplete.handle) &&
        Objects.equals(this.url, articleComplete.url) &&
        Objects.equals(this.urlPublicHtml, articleComplete.urlPublicHtml) &&
        Objects.equals(this.urlPublicApi, articleComplete.urlPublicApi) &&
        Objects.equals(this.urlPrivateHtml, articleComplete.urlPrivateHtml) &&
        Objects.equals(this.urlPrivateApi, articleComplete.urlPrivateApi) &&
        Objects.equals(this.timeline, articleComplete.timeline) &&
        Objects.equals(this.thumb, articleComplete.thumb) &&
        Objects.equals(this.definedType, articleComplete.definedType) &&
        Objects.equals(this.definedTypeName, articleComplete.definedTypeName) &&
        Objects.equals(this.figshareUrl, articleComplete.figshareUrl) &&
        Objects.equals(this.downloadDisabled, articleComplete.downloadDisabled) &&
        Objects.equals(this.files, articleComplete.files) &&
        Objects.equals(this.authors, articleComplete.authors) &&
        Objects.equals(this.customFields, articleComplete.customFields) &&
        Objects.equals(this.embargoOptions, articleComplete.embargoOptions) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(citation, confidentialReason, isConfidential, size, funding, fundingList, tags, version, isActive, isMetadataRecord, metadataReason, status, description, isEmbargoed, isPublic, createdDate, hasLinkedFile, categories, license, embargoTitle, embargoReason, references, relatedMaterials, id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName, figshareUrl, downloadDisabled, files, authors, customFields, embargoOptions, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ArticleComplete {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    citation: ").append(toIndentedString(citation)).append("\n");
    sb.append("    confidentialReason: ").append(toIndentedString(confidentialReason)).append("\n");
    sb.append("    isConfidential: ").append(toIndentedString(isConfidential)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    isActive: ").append(toIndentedString(isActive)).append("\n");
    sb.append("    isMetadataRecord: ").append(toIndentedString(isMetadataRecord)).append("\n");
    sb.append("    metadataReason: ").append(toIndentedString(metadataReason)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    isEmbargoed: ").append(toIndentedString(isEmbargoed)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("    hasLinkedFile: ").append(toIndentedString(hasLinkedFile)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    embargoTitle: ").append(toIndentedString(embargoTitle)).append("\n");
    sb.append("    embargoReason: ").append(toIndentedString(embargoReason)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    relatedMaterials: ").append(toIndentedString(relatedMaterials)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    urlPublicHtml: ").append(toIndentedString(urlPublicHtml)).append("\n");
    sb.append("    urlPublicApi: ").append(toIndentedString(urlPublicApi)).append("\n");
    sb.append("    urlPrivateHtml: ").append(toIndentedString(urlPrivateHtml)).append("\n");
    sb.append("    urlPrivateApi: ").append(toIndentedString(urlPrivateApi)).append("\n");
    sb.append("    timeline: ").append(toIndentedString(timeline)).append("\n");
    sb.append("    thumb: ").append(toIndentedString(thumb)).append("\n");
    sb.append("    definedType: ").append(toIndentedString(definedType)).append("\n");
    sb.append("    definedTypeName: ").append(toIndentedString(definedTypeName)).append("\n");
    sb.append("    figshareUrl: ").append(toIndentedString(figshareUrl)).append("\n");
    sb.append("    downloadDisabled: ").append(toIndentedString(downloadDisabled)).append("\n");
    sb.append("    files: ").append(toIndentedString(files)).append("\n");
    sb.append("    authors: ").append(toIndentedString(authors)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("    embargoOptions: ").append(toIndentedString(embargoOptions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

