/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ArticleEmbargo
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ArticleEmbargo {
  @SerializedName("is_embargoed")
  private Boolean isEmbargoed = null;

  @SerializedName("embargo_title")
  private String embargoTitle = null;

  @SerializedName("embargo_reason")
  private String embargoReason = null;

  @SerializedName("embargo_options")
  private List<Object> embargoOptions = new ArrayList<Object>();

  public ArticleEmbargo isEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
    return this;
  }

   /**
   * True if embargoed
   * @return isEmbargoed
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if embargoed")
  public Boolean isIsEmbargoed() {
    return isEmbargoed;
  }

  public void setIsEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
  }

  public ArticleEmbargo embargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
    return this;
  }

   /**
   * Title for embargo
   * @return embargoTitle
  **/
  @ApiModelProperty(example = "File(s) under embargo", required = true, value = "Title for embargo")
  public String getEmbargoTitle() {
    return embargoTitle;
  }

  public void setEmbargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
  }

  public ArticleEmbargo embargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
    return this;
  }

   /**
   * Reason for embargo
   * @return embargoReason
  **/
  @ApiModelProperty(example = "", required = true, value = "Reason for embargo")
  public String getEmbargoReason() {
    return embargoReason;
  }

  public void setEmbargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
  }

  public ArticleEmbargo embargoOptions(List<Object> embargoOptions) {
    this.embargoOptions = embargoOptions;
    return this;
  }

  public ArticleEmbargo addEmbargoOptionsItem(Object embargoOptionsItem) {
    this.embargoOptions.add(embargoOptionsItem);
    return this;
  }

   /**
   * List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.
   * @return embargoOptions
  **/
  @ApiModelProperty(example = "[{\"id\":13,\"type\":\"ip_range\",\"group_ids\":[],\"ip_name\":\"bacau\"},{\"id\":12,\"type\":\"logged_in\",\"ip_name\":\"\",\"group_ids\":[550,9448]}]", required = true, value = "List of embargo permissions that are associated with the article. If the type is logged_in and the group_ids list is empty, then the whole institution can see the article; if there are multiple group_ids, then only users that are under those groups can see the article.")
  public List<Object> getEmbargoOptions() {
    return embargoOptions;
  }

  public void setEmbargoOptions(List<Object> embargoOptions) {
    this.embargoOptions = embargoOptions;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ArticleEmbargo articleEmbargo = (ArticleEmbargo) o;
    return Objects.equals(this.isEmbargoed, articleEmbargo.isEmbargoed) &&
        Objects.equals(this.embargoTitle, articleEmbargo.embargoTitle) &&
        Objects.equals(this.embargoReason, articleEmbargo.embargoReason) &&
        Objects.equals(this.embargoOptions, articleEmbargo.embargoOptions);
  }

  @Override
  public int hashCode() {
    return Objects.hash(isEmbargoed, embargoTitle, embargoReason, embargoOptions);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ArticleEmbargo {\n");
    
    sb.append("    isEmbargoed: ").append(toIndentedString(isEmbargoed)).append("\n");
    sb.append("    embargoTitle: ").append(toIndentedString(embargoTitle)).append("\n");
    sb.append("    embargoReason: ").append(toIndentedString(embargoReason)).append("\n");
    sb.append("    embargoOptions: ").append(toIndentedString(embargoOptions)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

