/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CommonSearch;
import java.io.IOException;

/**
 * ArticleSearch
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ArticleSearch extends CommonSearch {
  @SerializedName("search_for")
  private String searchFor = null;

  @SerializedName("page")
  private Long page = null;

  @SerializedName("page_size")
  private Long pageSize = 10l;

  @SerializedName("limit")
  private Long limit = null;

  @SerializedName("offset")
  private Long offset = null;

  @SerializedName("institution")
  private Integer institution = null;

  @SerializedName("published_since")
  private String publishedSince = null;

  @SerializedName("modified_since")
  private String modifiedSince = null;

  @SerializedName("group")
  private Integer group = null;

  @SerializedName("resource_doi")
  private String resourceDoi = null;

  @SerializedName("item_type")
  private Long itemType = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("handle")
  private String handle = null;

  @SerializedName("project_id")
  private Long projectId = null;

  /**
   * The field by which to order
   */
  @JsonAdapter(OrderEnum.Adapter.class)
  public enum OrderEnum {
    CREATED_DATE("created_date"),
    
    PUBLISHED_DATE("published_date"),
    
    MODIFIED_DATE("modified_date"),
    
    VIEWS("views"),
    
    SHARES("shares"),
    
    DOWNLOADS("downloads"),
    
    CITES("cites");

    private String value;

    OrderEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static OrderEnum fromValue(String text) {
      for (OrderEnum b : OrderEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<OrderEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final OrderEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public OrderEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return OrderEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("order")
  private OrderEnum order = OrderEnum.CREATED_DATE;

  public ArticleSearch searchFor(String searchFor) {
    this.searchFor = searchFor;
    return this;
  }

   /**
   * Search term
   * @return searchFor
  **/
  @ApiModelProperty(example = "figshare", value = "Search term")
  public String getSearchFor() {
    return searchFor;
  }

  public void setSearchFor(String searchFor) {
    this.searchFor = searchFor;
  }

  public ArticleSearch page(Long page) {
    this.page = page;
    return this;
  }

   /**
   * Page number. Used for pagination with page_size
   * minimum: 1
   * maximum: 5000
   * @return page
  **/
  @ApiModelProperty(example = "1", value = "Page number. Used for pagination with page_size")
  public Long getPage() {
    return page;
  }

  public void setPage(Long page) {
    this.page = page;
  }

  public ArticleSearch pageSize(Long pageSize) {
    this.pageSize = pageSize;
    return this;
  }

   /**
   * The number of results included on a page. Used for pagination with page
   * minimum: 1
   * maximum: 1000
   * @return pageSize
  **/
  @ApiModelProperty(example = "10", value = "The number of results included on a page. Used for pagination with page")
  public Long getPageSize() {
    return pageSize;
  }

  public void setPageSize(Long pageSize) {
    this.pageSize = pageSize;
  }

  public ArticleSearch limit(Long limit) {
    this.limit = limit;
    return this;
  }

   /**
   * Number of results included on a page. Used for pagination with query
   * minimum: 1
   * maximum: 1000
   * @return limit
  **/
  @ApiModelProperty(example = "10", value = "Number of results included on a page. Used for pagination with query")
  public Long getLimit() {
    return limit;
  }

  public void setLimit(Long limit) {
    this.limit = limit;
  }

  public ArticleSearch offset(Long offset) {
    this.offset = offset;
    return this;
  }

   /**
   * Where to start the listing(the offset of the first result). Used for pagination with limit
   * minimum: 0
   * maximum: 5000
   * @return offset
  **/
  @ApiModelProperty(example = "0", value = "Where to start the listing(the offset of the first result). Used for pagination with limit")
  public Long getOffset() {
    return offset;
  }

  public void setOffset(Long offset) {
    this.offset = offset;
  }

  public ArticleSearch institution(Integer institution) {
    this.institution = institution;
    return this;
  }

   /**
   * only return collections from this institution
   * @return institution
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this institution")
  public Integer getInstitution() {
    return institution;
  }

  public void setInstitution(Integer institution) {
    this.institution = institution;
  }

  public ArticleSearch publishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
    return this;
  }

   /**
   * Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return publishedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article publishing date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getPublishedSince() {
    return publishedSince;
  }

  public void setPublishedSince(String publishedSince) {
    this.publishedSince = publishedSince;
  }

  public ArticleSearch modifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
    return this;
  }

   /**
   * Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD
   * @return modifiedSince
  **/
  @ApiModelProperty(example = "2017-12-22", value = "Filter by article modified date. Will only return articles published after the date. date(ISO 8601) YYYY-MM-DD")
  public String getModifiedSince() {
    return modifiedSince;
  }

  public void setModifiedSince(String modifiedSince) {
    this.modifiedSince = modifiedSince;
  }

  public ArticleSearch group(Integer group) {
    this.group = group;
    return this;
  }

   /**
   * only return collections from this group
   * @return group
  **/
  @ApiModelProperty(example = "2000013", value = "only return collections from this group")
  public Integer getGroup() {
    return group;
  }

  public void setGroup(Integer group) {
    this.group = group;
  }

  public ArticleSearch resourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
    return this;
  }

   /**
   * Only return articles with this resource_doi
   * @return resourceDoi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1407024", value = "Only return articles with this resource_doi")
  public String getResourceDoi() {
    return resourceDoi;
  }

  public void setResourceDoi(String resourceDoi) {
    this.resourceDoi = resourceDoi;
  }

  public ArticleSearch itemType(Long itemType) {
    this.itemType = itemType;
    return this;
  }

   /**
   * Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model
   * @return itemType
  **/
  @ApiModelProperty(example = "1", value = "Only return articles with the respective type. Mapping for item_type is: 1 - Figure, 2 - Media, 3 - Dataset, 5 - Poster, 6 - Journal contribution, 7 - Presentation, 8 - Thesis, 9 - Software, 11 - Online resource, 12 - Preprint, 13 - Book, 14 - Conference contribution, 15 - Chapter, 16 - Peer review, 17 - Educational resource, 18 - Report, 19 - Standard, 20 - Composition, 21 - Funding, 22 - Physical object, 23 - Data management plan, 24 - Workflow, 25 - Monograph, 26 - Performance, 27 - Event, 28 - Service, 29 - Model")
  public Long getItemType() {
    return itemType;
  }

  public void setItemType(Long itemType) {
    this.itemType = itemType;
  }

  public ArticleSearch doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * Only return articles with this doi
   * @return doi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1407024", value = "Only return articles with this doi")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public ArticleSearch handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Only return articles with this handle
   * @return handle
  **/
  @ApiModelProperty(example = "111084/m9.figshare.14074", value = "Only return articles with this handle")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public ArticleSearch projectId(Long projectId) {
    this.projectId = projectId;
    return this;
  }

   /**
   * Only return articles in this project
   * @return projectId
  **/
  @ApiModelProperty(example = "1", value = "Only return articles in this project")
  public Long getProjectId() {
    return projectId;
  }

  public void setProjectId(Long projectId) {
    this.projectId = projectId;
  }

  public ArticleSearch order(OrderEnum order) {
    this.order = order;
    return this;
  }

   /**
   * The field by which to order
   * @return order
  **/
  @ApiModelProperty(example = "published_date", value = "The field by which to order")
  public OrderEnum getOrder() {
    return order;
  }

  public void setOrder(OrderEnum order) {
    this.order = order;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ArticleSearch articleSearch = (ArticleSearch) o;
    return Objects.equals(this.searchFor, articleSearch.searchFor) &&
        Objects.equals(this.page, articleSearch.page) &&
        Objects.equals(this.pageSize, articleSearch.pageSize) &&
        Objects.equals(this.limit, articleSearch.limit) &&
        Objects.equals(this.offset, articleSearch.offset) &&
        Objects.equals(this.institution, articleSearch.institution) &&
        Objects.equals(this.publishedSince, articleSearch.publishedSince) &&
        Objects.equals(this.modifiedSince, articleSearch.modifiedSince) &&
        Objects.equals(this.group, articleSearch.group) &&
        Objects.equals(this.resourceDoi, articleSearch.resourceDoi) &&
        Objects.equals(this.itemType, articleSearch.itemType) &&
        Objects.equals(this.doi, articleSearch.doi) &&
        Objects.equals(this.handle, articleSearch.handle) &&
        Objects.equals(this.projectId, articleSearch.projectId) &&
        Objects.equals(this.order, articleSearch.order) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(searchFor, page, pageSize, limit, offset, institution, publishedSince, modifiedSince, group, resourceDoi, itemType, doi, handle, projectId, order, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ArticleSearch {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    searchFor: ").append(toIndentedString(searchFor)).append("\n");
    sb.append("    page: ").append(toIndentedString(page)).append("\n");
    sb.append("    pageSize: ").append(toIndentedString(pageSize)).append("\n");
    sb.append("    limit: ").append(toIndentedString(limit)).append("\n");
    sb.append("    offset: ").append(toIndentedString(offset)).append("\n");
    sb.append("    institution: ").append(toIndentedString(institution)).append("\n");
    sb.append("    publishedSince: ").append(toIndentedString(publishedSince)).append("\n");
    sb.append("    modifiedSince: ").append(toIndentedString(modifiedSince)).append("\n");
    sb.append("    group: ").append(toIndentedString(group)).append("\n");
    sb.append("    resourceDoi: ").append(toIndentedString(resourceDoi)).append("\n");
    sb.append("    itemType: ").append(toIndentedString(itemType)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    projectId: ").append(toIndentedString(projectId)).append("\n");
    sb.append("    order: ").append(toIndentedString(order)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

