/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.ArticleComplete;
import io.swagger.client.model.Curation;
import java.io.IOException;

/**
 * CurationDetail
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class CurationDetail extends Curation {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("group_id")
  private Long groupId = null;

  @SerializedName("account_id")
  private Long accountId = null;

  @SerializedName("assigned_to")
  private Long assignedTo = null;

  @SerializedName("article_id")
  private Long articleId = null;

  @SerializedName("version")
  private Long version = null;

  @SerializedName("comments_count")
  private Long commentsCount = null;

  @SerializedName("created_date")
  private String createdDate = null;

  @SerializedName("modified_date")
  private String modifiedDate = null;

  @SerializedName("item")
  private ArticleComplete item = null;

  public CurationDetail id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * The review id
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The review id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public CurationDetail groupId(Long groupId) {
    this.groupId = groupId;
    return this;
  }

   /**
   * The group in which the article is present.
   * @return groupId
  **/
  @ApiModelProperty(required = true, value = "The group in which the article is present.")
  public Long getGroupId() {
    return groupId;
  }

  public void setGroupId(Long groupId) {
    this.groupId = groupId;
  }

  public CurationDetail accountId(Long accountId) {
    this.accountId = accountId;
    return this;
  }

   /**
   * The ID of the account of the owner of the article of this review.
   * @return accountId
  **/
  @ApiModelProperty(required = true, value = "The ID of the account of the owner of the article of this review.")
  public Long getAccountId() {
    return accountId;
  }

  public void setAccountId(Long accountId) {
    this.accountId = accountId;
  }

  public CurationDetail assignedTo(Long assignedTo) {
    this.assignedTo = assignedTo;
    return this;
  }

   /**
   * The ID of the account to which this review is assigned.
   * @return assignedTo
  **/
  @ApiModelProperty(required = true, value = "The ID of the account to which this review is assigned.")
  public Long getAssignedTo() {
    return assignedTo;
  }

  public void setAssignedTo(Long assignedTo) {
    this.assignedTo = assignedTo;
  }

  public CurationDetail articleId(Long articleId) {
    this.articleId = articleId;
    return this;
  }

   /**
   * The ID of the article of this review.
   * @return articleId
  **/
  @ApiModelProperty(required = true, value = "The ID of the article of this review.")
  public Long getArticleId() {
    return articleId;
  }

  public void setArticleId(Long articleId) {
    this.articleId = articleId;
  }

  public CurationDetail version(Long version) {
    this.version = version;
    return this;
  }

   /**
   * The Version number of the article in review.
   * @return version
  **/
  @ApiModelProperty(required = true, value = "The Version number of the article in review.")
  public Long getVersion() {
    return version;
  }

  public void setVersion(Long version) {
    this.version = version;
  }

  public CurationDetail commentsCount(Long commentsCount) {
    this.commentsCount = commentsCount;
    return this;
  }

   /**
   * The number of comments in the review.
   * @return commentsCount
  **/
  @ApiModelProperty(required = true, value = "The number of comments in the review.")
  public Long getCommentsCount() {
    return commentsCount;
  }

  public void setCommentsCount(Long commentsCount) {
    this.commentsCount = commentsCount;
  }

  public CurationDetail createdDate(String createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * The creation date of the review.
   * @return createdDate
  **/
  @ApiModelProperty(required = true, value = "The creation date of the review.")
  public String getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(String createdDate) {
    this.createdDate = createdDate;
  }

  public CurationDetail modifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
    return this;
  }

   /**
   * The date the review has been modified.
   * @return modifiedDate
  **/
  @ApiModelProperty(required = true, value = "The date the review has been modified.")
  public String getModifiedDate() {
    return modifiedDate;
  }

  public void setModifiedDate(String modifiedDate) {
    this.modifiedDate = modifiedDate;
  }

  public CurationDetail item(ArticleComplete item) {
    this.item = item;
    return this;
  }

   /**
   * Article details
   * @return item
  **/
  @ApiModelProperty(required = true, value = "Article details")
  public ArticleComplete getItem() {
    return item;
  }

  public void setItem(ArticleComplete item) {
    this.item = item;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CurationDetail curationDetail = (CurationDetail) o;
    return Objects.equals(this.id, curationDetail.id) &&
        Objects.equals(this.groupId, curationDetail.groupId) &&
        Objects.equals(this.accountId, curationDetail.accountId) &&
        Objects.equals(this.assignedTo, curationDetail.assignedTo) &&
        Objects.equals(this.articleId, curationDetail.articleId) &&
        Objects.equals(this.version, curationDetail.version) &&
        Objects.equals(this.commentsCount, curationDetail.commentsCount) &&
        Objects.equals(this.createdDate, curationDetail.createdDate) &&
        Objects.equals(this.modifiedDate, curationDetail.modifiedDate) &&
        Objects.equals(this.item, curationDetail.item) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, groupId, accountId, assignedTo, articleId, version, commentsCount, createdDate, modifiedDate, item, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CurationDetail {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    groupId: ").append(toIndentedString(groupId)).append("\n");
    sb.append("    accountId: ").append(toIndentedString(accountId)).append("\n");
    sb.append("    assignedTo: ").append(toIndentedString(assignedTo)).append("\n");
    sb.append("    articleId: ").append(toIndentedString(articleId)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    commentsCount: ").append(toIndentedString(commentsCount)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("    modifiedDate: ").append(toIndentedString(modifiedDate)).append("\n");
    sb.append("    item: ").append(toIndentedString(item)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

