/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * FileCreator
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class FileCreator {
  @SerializedName("link")
  private String link = null;

  @SerializedName("md5")
  private String md5 = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("size")
  private Long size = null;

  @SerializedName("folder_path")
  private String folderPath = null;

  public FileCreator link(String link) {
    this.link = link;
    return this;
  }

   /**
   * Url for an existing file that will not be uploaded to Figshare
   * @return link
  **/
  @ApiModelProperty(example = "http://figshare.com/file.txt", value = "Url for an existing file that will not be uploaded to Figshare")
  public String getLink() {
    return link;
  }

  public void setLink(String link) {
    this.link = link;
  }

  public FileCreator md5(String md5) {
    this.md5 = md5;
    return this;
  }

   /**
   * MD5 sum pre-computed on client side.
   * @return md5
  **/
  @ApiModelProperty(example = "6c16e6e7d7587bd078e5117dda01d565", value = "MD5 sum pre-computed on client side.")
  public String getMd5() {
    return md5;
  }

  public void setMd5(String md5) {
    this.md5 = md5;
  }

  public FileCreator name(String name) {
    this.name = name;
    return this;
  }

   /**
   * File name including the extension; can be omitted only for linked files.
   * @return name
  **/
  @ApiModelProperty(example = "test.py", value = "File name including the extension; can be omitted only for linked files.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public FileCreator size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * File size in bytes; can be omitted only for linked files.
   * @return size
  **/
  @ApiModelProperty(example = "70", value = "File size in bytes; can be omitted only for linked files.")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public FileCreator folderPath(String folderPath) {
    this.folderPath = folderPath;
    return this;
  }

   /**
   * Unix-style directory path of the file; only available if the file was uploaded within a folder structure
   * @return folderPath
  **/
  @ApiModelProperty(example = "/level1/level2/level3", value = "Unix-style directory path of the file; only available if the file was uploaded within a folder structure")
  public String getFolderPath() {
    return folderPath;
  }

  public void setFolderPath(String folderPath) {
    this.folderPath = folderPath;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FileCreator fileCreator = (FileCreator) o;
    return Objects.equals(this.link, fileCreator.link) &&
        Objects.equals(this.md5, fileCreator.md5) &&
        Objects.equals(this.name, fileCreator.name) &&
        Objects.equals(this.size, fileCreator.size) &&
        Objects.equals(this.folderPath, fileCreator.folderPath);
  }

  @Override
  public int hashCode() {
    return Objects.hash(link, md5, name, size, folderPath);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FileCreator {\n");
    
    sb.append("    link: ").append(toIndentedString(link)).append("\n");
    sb.append("    md5: ").append(toIndentedString(md5)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    folderPath: ").append(toIndentedString(folderPath)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

