/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.PublicFile;
import java.io.IOException;

/**
 * PrivateFile
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class PrivateFile extends PublicFile {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("size")
  private Long size = null;

  @SerializedName("is_link_only")
  private Boolean isLinkOnly = null;

  @SerializedName("download_url")
  private String downloadUrl = null;

  @SerializedName("supplied_md5")
  private String suppliedMd5 = null;

  @SerializedName("computed_md5")
  private String computedMd5 = null;

  @SerializedName("mimetype")
  private String mimetype = null;

  @SerializedName("viewer_type")
  private String viewerType = null;

  @SerializedName("preview_state")
  private String previewState = null;

  @SerializedName("upload_url")
  private String uploadUrl = null;

  @SerializedName("upload_token")
  private String uploadToken = null;

  @SerializedName("is_attached_to_public_version")
  private Boolean isAttachedToPublicVersion = null;

  public PrivateFile id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * File id
   * @return id
  **/
  @ApiModelProperty(example = "3000002", required = true, value = "File id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public PrivateFile name(String name) {
    this.name = name;
    return this;
  }

   /**
   * File name
   * @return name
  **/
  @ApiModelProperty(example = "test.xls", required = true, value = "File name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public PrivateFile size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * File size
   * @return size
  **/
  @ApiModelProperty(example = "14848", required = true, value = "File size")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public PrivateFile isLinkOnly(Boolean isLinkOnly) {
    this.isLinkOnly = isLinkOnly;
    return this;
  }

   /**
   * True if file is hosted somewhere else
   * @return isLinkOnly
  **/
  @ApiModelProperty(example = "false", required = true, value = "True if file is hosted somewhere else")
  public Boolean isIsLinkOnly() {
    return isLinkOnly;
  }

  public void setIsLinkOnly(Boolean isLinkOnly) {
    this.isLinkOnly = isLinkOnly;
  }

  public PrivateFile downloadUrl(String downloadUrl) {
    this.downloadUrl = downloadUrl;
    return this;
  }

   /**
   * Url for file download
   * @return downloadUrl
  **/
  @ApiModelProperty(example = "https://ndownloader.figshare.com/files/3000002", required = true, value = "Url for file download")
  public String getDownloadUrl() {
    return downloadUrl;
  }

  public void setDownloadUrl(String downloadUrl) {
    this.downloadUrl = downloadUrl;
  }

  public PrivateFile suppliedMd5(String suppliedMd5) {
    this.suppliedMd5 = suppliedMd5;
    return this;
  }

   /**
   * File supplied md5
   * @return suppliedMd5
  **/
  @ApiModelProperty(example = "043a51806d646e88cafbf19e7b82846f", required = true, value = "File supplied md5")
  public String getSuppliedMd5() {
    return suppliedMd5;
  }

  public void setSuppliedMd5(String suppliedMd5) {
    this.suppliedMd5 = suppliedMd5;
  }

  public PrivateFile computedMd5(String computedMd5) {
    this.computedMd5 = computedMd5;
    return this;
  }

   /**
   * File computed md5
   * @return computedMd5
  **/
  @ApiModelProperty(example = "043a51806d646e88cafbf19e7b82846f", required = true, value = "File computed md5")
  public String getComputedMd5() {
    return computedMd5;
  }

  public void setComputedMd5(String computedMd5) {
    this.computedMd5 = computedMd5;
  }

  public PrivateFile mimetype(String mimetype) {
    this.mimetype = mimetype;
    return this;
  }

   /**
   * MIME Type of the file, it defaults to an empty string
   * @return mimetype
  **/
  @ApiModelProperty(example = "application/pdf", value = "MIME Type of the file, it defaults to an empty string")
  public String getMimetype() {
    return mimetype;
  }

  public void setMimetype(String mimetype) {
    this.mimetype = mimetype;
  }

  public PrivateFile viewerType(String viewerType) {
    this.viewerType = viewerType;
    return this;
  }

   /**
   * File viewer type
   * @return viewerType
  **/
  @ApiModelProperty(required = true, value = "File viewer type")
  public String getViewerType() {
    return viewerType;
  }

  public void setViewerType(String viewerType) {
    this.viewerType = viewerType;
  }

  public PrivateFile previewState(String previewState) {
    this.previewState = previewState;
    return this;
  }

   /**
   * File preview state
   * @return previewState
  **/
  @ApiModelProperty(example = "preview not available", required = true, value = "File preview state")
  public String getPreviewState() {
    return previewState;
  }

  public void setPreviewState(String previewState) {
    this.previewState = previewState;
  }

  public PrivateFile uploadUrl(String uploadUrl) {
    this.uploadUrl = uploadUrl;
    return this;
  }

   /**
   * Upload url for file
   * @return uploadUrl
  **/
  @ApiModelProperty(example = "https://uploads.figshare.com", required = true, value = "Upload url for file")
  public String getUploadUrl() {
    return uploadUrl;
  }

  public void setUploadUrl(String uploadUrl) {
    this.uploadUrl = uploadUrl;
  }

  public PrivateFile uploadToken(String uploadToken) {
    this.uploadToken = uploadToken;
    return this;
  }

   /**
   * Token for file upload
   * @return uploadToken
  **/
  @ApiModelProperty(example = "9dfc5fe3-d617-4d93-ac11-8afe7e984a4b", required = true, value = "Token for file upload")
  public String getUploadToken() {
    return uploadToken;
  }

  public void setUploadToken(String uploadToken) {
    this.uploadToken = uploadToken;
  }

  public PrivateFile isAttachedToPublicVersion(Boolean isAttachedToPublicVersion) {
    this.isAttachedToPublicVersion = isAttachedToPublicVersion;
    return this;
  }

   /**
   * True if the file is attached to a public item version
   * @return isAttachedToPublicVersion
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if the file is attached to a public item version")
  public Boolean isIsAttachedToPublicVersion() {
    return isAttachedToPublicVersion;
  }

  public void setIsAttachedToPublicVersion(Boolean isAttachedToPublicVersion) {
    this.isAttachedToPublicVersion = isAttachedToPublicVersion;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PrivateFile privateFile = (PrivateFile) o;
    return Objects.equals(this.id, privateFile.id) &&
        Objects.equals(this.name, privateFile.name) &&
        Objects.equals(this.size, privateFile.size) &&
        Objects.equals(this.isLinkOnly, privateFile.isLinkOnly) &&
        Objects.equals(this.downloadUrl, privateFile.downloadUrl) &&
        Objects.equals(this.suppliedMd5, privateFile.suppliedMd5) &&
        Objects.equals(this.computedMd5, privateFile.computedMd5) &&
        Objects.equals(this.mimetype, privateFile.mimetype) &&
        Objects.equals(this.viewerType, privateFile.viewerType) &&
        Objects.equals(this.previewState, privateFile.previewState) &&
        Objects.equals(this.uploadUrl, privateFile.uploadUrl) &&
        Objects.equals(this.uploadToken, privateFile.uploadToken) &&
        Objects.equals(this.isAttachedToPublicVersion, privateFile.isAttachedToPublicVersion) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, size, isLinkOnly, downloadUrl, suppliedMd5, computedMd5, mimetype, viewerType, previewState, uploadUrl, uploadToken, isAttachedToPublicVersion, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PrivateFile {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    isLinkOnly: ").append(toIndentedString(isLinkOnly)).append("\n");
    sb.append("    downloadUrl: ").append(toIndentedString(downloadUrl)).append("\n");
    sb.append("    suppliedMd5: ").append(toIndentedString(suppliedMd5)).append("\n");
    sb.append("    computedMd5: ").append(toIndentedString(computedMd5)).append("\n");
    sb.append("    mimetype: ").append(toIndentedString(mimetype)).append("\n");
    sb.append("    viewerType: ").append(toIndentedString(viewerType)).append("\n");
    sb.append("    previewState: ").append(toIndentedString(previewState)).append("\n");
    sb.append("    uploadUrl: ").append(toIndentedString(uploadUrl)).append("\n");
    sb.append("    uploadToken: ").append(toIndentedString(uploadToken)).append("\n");
    sb.append("    isAttachedToPublicVersion: ").append(toIndentedString(isAttachedToPublicVersion)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

