/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Article;
import io.swagger.client.model.Category;
import io.swagger.client.model.FundingInformation;
import io.swagger.client.model.License;
import io.swagger.client.model.RelatedMaterial;
import io.swagger.client.model.Timeline;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ProjectArticle
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ProjectArticle extends Article {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("doi")
  private String doi = null;

  @SerializedName("handle")
  private String handle = null;

  @SerializedName("url")
  private String url = null;

  @SerializedName("url_public_html")
  private String urlPublicHtml = null;

  @SerializedName("url_public_api")
  private String urlPublicApi = null;

  @SerializedName("url_private_html")
  private String urlPrivateHtml = null;

  @SerializedName("url_private_api")
  private String urlPrivateApi = null;

  @SerializedName("timeline")
  private Timeline timeline = null;

  @SerializedName("thumb")
  private String thumb = null;

  @SerializedName("defined_type")
  private Long definedType = null;

  @SerializedName("defined_type_name")
  private String definedTypeName = null;

  @SerializedName("citation")
  private String citation = null;

  @SerializedName("confidential_reason")
  private String confidentialReason = null;

  @SerializedName("is_confidential")
  private Boolean isConfidential = null;

  @SerializedName("size")
  private Long size = null;

  @SerializedName("funding")
  private String funding = null;

  @SerializedName("funding_list")
  private List<FundingInformation> fundingList = new ArrayList<FundingInformation>();

  @SerializedName("tags")
  private List<String> tags = new ArrayList<String>();

  @SerializedName("version")
  private Long version = null;

  @SerializedName("is_active")
  private Boolean isActive = null;

  @SerializedName("is_metadata_record")
  private Boolean isMetadataRecord = null;

  @SerializedName("metadata_reason")
  private String metadataReason = null;

  @SerializedName("status")
  private String status = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("is_embargoed")
  private Boolean isEmbargoed = null;

  @SerializedName("is_public")
  private Boolean isPublic = null;

  @SerializedName("created_date")
  private String createdDate = null;

  @SerializedName("has_linked_file")
  private Boolean hasLinkedFile = null;

  @SerializedName("categories")
  private List<Category> categories = new ArrayList<Category>();

  @SerializedName("license")
  private License license = null;

  @SerializedName("embargo_title")
  private String embargoTitle = null;

  @SerializedName("embargo_reason")
  private String embargoReason = null;

  @SerializedName("references")
  private List<String> references = new ArrayList<String>();

  @SerializedName("related_materials")
  private List<RelatedMaterial> relatedMaterials = null;

  public ProjectArticle id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Unique identifier for article
   * @return id
  **/
  @ApiModelProperty(example = "1434614", required = true, value = "Unique identifier for article")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ProjectArticle title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Title of article
   * @return title
  **/
  @ApiModelProperty(example = "Test article title", required = true, value = "Title of article")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ProjectArticle doi(String doi) {
    this.doi = doi;
    return this;
  }

   /**
   * DOI
   * @return doi
  **/
  @ApiModelProperty(example = "10.6084/m9.figshare.1434614", required = true, value = "DOI")
  public String getDoi() {
    return doi;
  }

  public void setDoi(String doi) {
    this.doi = doi;
  }

  public ProjectArticle handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Handle
   * @return handle
  **/
  @ApiModelProperty(example = "111184/figshare.1234", required = true, value = "Handle")
  public String getHandle() {
    return handle;
  }

  public void setHandle(String handle) {
    this.handle = handle;
  }

  public ProjectArticle url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint for article
   * @return url
  **/
  @ApiModelProperty(example = "http://api.figshare.com/articles/1434614", required = true, value = "Api endpoint for article")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ProjectArticle urlPublicHtml(String urlPublicHtml) {
    this.urlPublicHtml = urlPublicHtml;
    return this;
  }

   /**
   * Public site endpoint for article
   * @return urlPublicHtml
  **/
  @ApiModelProperty(example = "https://figshare.com/articles/media/Test_article_title/1434614", required = true, value = "Public site endpoint for article")
  public String getUrlPublicHtml() {
    return urlPublicHtml;
  }

  public void setUrlPublicHtml(String urlPublicHtml) {
    this.urlPublicHtml = urlPublicHtml;
  }

  public ProjectArticle urlPublicApi(String urlPublicApi) {
    this.urlPublicApi = urlPublicApi;
    return this;
  }

   /**
   * Public Api endpoint for article
   * @return urlPublicApi
  **/
  @ApiModelProperty(example = "https://api.figshare.com/articles/1434614", required = true, value = "Public Api endpoint for article")
  public String getUrlPublicApi() {
    return urlPublicApi;
  }

  public void setUrlPublicApi(String urlPublicApi) {
    this.urlPublicApi = urlPublicApi;
  }

  public ProjectArticle urlPrivateHtml(String urlPrivateHtml) {
    this.urlPrivateHtml = urlPrivateHtml;
    return this;
  }

   /**
   * Private site endpoint for article
   * @return urlPrivateHtml
  **/
  @ApiModelProperty(example = "https://figshare.com/account/articles/1434614", required = true, value = "Private site endpoint for article")
  public String getUrlPrivateHtml() {
    return urlPrivateHtml;
  }

  public void setUrlPrivateHtml(String urlPrivateHtml) {
    this.urlPrivateHtml = urlPrivateHtml;
  }

  public ProjectArticle urlPrivateApi(String urlPrivateApi) {
    this.urlPrivateApi = urlPrivateApi;
    return this;
  }

   /**
   * Private Api endpoint for article
   * @return urlPrivateApi
  **/
  @ApiModelProperty(example = "https://api.figshare.com/account/articles/1434614", required = true, value = "Private Api endpoint for article")
  public String getUrlPrivateApi() {
    return urlPrivateApi;
  }

  public void setUrlPrivateApi(String urlPrivateApi) {
    this.urlPrivateApi = urlPrivateApi;
  }

  public ProjectArticle timeline(Timeline timeline) {
    this.timeline = timeline;
    return this;
  }

   /**
   * Various timeline dates
   * @return timeline
  **/
  @ApiModelProperty(required = true, value = "Various timeline dates")
  public Timeline getTimeline() {
    return timeline;
  }

  public void setTimeline(Timeline timeline) {
    this.timeline = timeline;
  }

  public ProjectArticle thumb(String thumb) {
    this.thumb = thumb;
    return this;
  }

   /**
   * Thumbnail image
   * @return thumb
  **/
  @ApiModelProperty(example = "https://ndownloader.figshare.com/files/123456789/preview/12345678/thumb.png", required = true, value = "Thumbnail image")
  public String getThumb() {
    return thumb;
  }

  public void setThumb(String thumb) {
    this.thumb = thumb;
  }

  public ProjectArticle definedType(Long definedType) {
    this.definedType = definedType;
    return this;
  }

   /**
   * Type of article identifier
   * @return definedType
  **/
  @ApiModelProperty(example = "3", required = true, value = "Type of article identifier")
  public Long getDefinedType() {
    return definedType;
  }

  public void setDefinedType(Long definedType) {
    this.definedType = definedType;
  }

  public ProjectArticle definedTypeName(String definedTypeName) {
    this.definedTypeName = definedTypeName;
    return this;
  }

   /**
   * Name of the article type identifier
   * @return definedTypeName
  **/
  @ApiModelProperty(example = "media", required = true, value = "Name of the article type identifier")
  public String getDefinedTypeName() {
    return definedTypeName;
  }

  public void setDefinedTypeName(String definedTypeName) {
    this.definedTypeName = definedTypeName;
  }

  public ProjectArticle citation(String citation) {
    this.citation = citation;
    return this;
  }

   /**
   * Article citation
   * @return citation
  **/
  @ApiModelProperty(example = "lilliput, figshare admin (2017): first project item. figshare.    Retrieved: 14 01, May 22, 2017 (GMT)", required = true, value = "Article citation")
  public String getCitation() {
    return citation;
  }

  public void setCitation(String citation) {
    this.citation = citation;
  }

  public ProjectArticle confidentialReason(String confidentialReason) {
    this.confidentialReason = confidentialReason;
    return this;
  }

   /**
   * Confidentiality reason
   * @return confidentialReason
  **/
  @ApiModelProperty(example = "none", required = true, value = "Confidentiality reason")
  public String getConfidentialReason() {
    return confidentialReason;
  }

  public void setConfidentialReason(String confidentialReason) {
    this.confidentialReason = confidentialReason;
  }

  public ProjectArticle isConfidential(Boolean isConfidential) {
    this.isConfidential = isConfidential;
    return this;
  }

   /**
   * Article Confidentiality
   * @return isConfidential
  **/
  @ApiModelProperty(example = "true", required = true, value = "Article Confidentiality")
  public Boolean isIsConfidential() {
    return isConfidential;
  }

  public void setIsConfidential(Boolean isConfidential) {
    this.isConfidential = isConfidential;
  }

  public ProjectArticle size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * Article size
   * @return size
  **/
  @ApiModelProperty(example = "69939", required = true, value = "Article size")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public ProjectArticle funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Article funding
   * @return funding
  **/
  @ApiModelProperty(example = "none", required = true, value = "Article funding")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ProjectArticle fundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ProjectArticle addFundingListItem(FundingInformation fundingListItem) {
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Full Article funding information
   * @return fundingList
  **/
  @ApiModelProperty(required = true, value = "Full Article funding information")
  public List<FundingInformation> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
  }

  public ProjectArticle tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public ProjectArticle addTagsItem(String tagsItem) {
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * List of article tags
   * @return tags
  **/
  @ApiModelProperty(example = "[\"t1\",\"t2\",\"t3\"]", required = true, value = "List of article tags")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public ProjectArticle version(Long version) {
    this.version = version;
    return this;
  }

   /**
   * Article version
   * @return version
  **/
  @ApiModelProperty(example = "1", required = true, value = "Article version")
  public Long getVersion() {
    return version;
  }

  public void setVersion(Long version) {
    this.version = version;
  }

  public ProjectArticle isActive(Boolean isActive) {
    this.isActive = isActive;
    return this;
  }

   /**
   * True if article is active
   * @return isActive
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if article is active")
  public Boolean isIsActive() {
    return isActive;
  }

  public void setIsActive(Boolean isActive) {
    this.isActive = isActive;
  }

  public ProjectArticle isMetadataRecord(Boolean isMetadataRecord) {
    this.isMetadataRecord = isMetadataRecord;
    return this;
  }

   /**
   * True if article has no files
   * @return isMetadataRecord
  **/
  @ApiModelProperty(example = "false", required = true, value = "True if article has no files")
  public Boolean isIsMetadataRecord() {
    return isMetadataRecord;
  }

  public void setIsMetadataRecord(Boolean isMetadataRecord) {
    this.isMetadataRecord = isMetadataRecord;
  }

  public ProjectArticle metadataReason(String metadataReason) {
    this.metadataReason = metadataReason;
    return this;
  }

   /**
   * Article metadata reason
   * @return metadataReason
  **/
  @ApiModelProperty(example = "hosted somewhere else", required = true, value = "Article metadata reason")
  public String getMetadataReason() {
    return metadataReason;
  }

  public void setMetadataReason(String metadataReason) {
    this.metadataReason = metadataReason;
  }

  public ProjectArticle status(String status) {
    this.status = status;
    return this;
  }

   /**
   * Article status
   * @return status
  **/
  @ApiModelProperty(example = "public", required = true, value = "Article status")
  public String getStatus() {
    return status;
  }

  public void setStatus(String status) {
    this.status = status;
  }

  public ProjectArticle description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Article description
   * @return description
  **/
  @ApiModelProperty(example = "article description", required = true, value = "Article description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ProjectArticle isEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
    return this;
  }

   /**
   * True if article is embargoed
   * @return isEmbargoed
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if article is embargoed")
  public Boolean isIsEmbargoed() {
    return isEmbargoed;
  }

  public void setIsEmbargoed(Boolean isEmbargoed) {
    this.isEmbargoed = isEmbargoed;
  }

  public ProjectArticle isPublic(Boolean isPublic) {
    this.isPublic = isPublic;
    return this;
  }

   /**
   * True if article is published
   * @return isPublic
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if article is published")
  public Boolean isIsPublic() {
    return isPublic;
  }

  public void setIsPublic(Boolean isPublic) {
    this.isPublic = isPublic;
  }

  public ProjectArticle createdDate(String createdDate) {
    this.createdDate = createdDate;
    return this;
  }

   /**
   * Date when article was created
   * @return createdDate
  **/
  @ApiModelProperty(example = "2017-05-18T11:49:03Z", required = true, value = "Date when article was created")
  public String getCreatedDate() {
    return createdDate;
  }

  public void setCreatedDate(String createdDate) {
    this.createdDate = createdDate;
  }

  public ProjectArticle hasLinkedFile(Boolean hasLinkedFile) {
    this.hasLinkedFile = hasLinkedFile;
    return this;
  }

   /**
   * True if any files are linked to the article
   * @return hasLinkedFile
  **/
  @ApiModelProperty(example = "true", required = true, value = "True if any files are linked to the article")
  public Boolean isHasLinkedFile() {
    return hasLinkedFile;
  }

  public void setHasLinkedFile(Boolean hasLinkedFile) {
    this.hasLinkedFile = hasLinkedFile;
  }

  public ProjectArticle categories(List<Category> categories) {
    this.categories = categories;
    return this;
  }

  public ProjectArticle addCategoriesItem(Category categoriesItem) {
    this.categories.add(categoriesItem);
    return this;
  }

   /**
   * List of categories selected for the article
   * @return categories
  **/
  @ApiModelProperty(required = true, value = "List of categories selected for the article")
  public List<Category> getCategories() {
    return categories;
  }

  public void setCategories(List<Category> categories) {
    this.categories = categories;
  }

  public ProjectArticle license(License license) {
    this.license = license;
    return this;
  }

   /**
   * Article selected license
   * @return license
  **/
  @ApiModelProperty(required = true, value = "Article selected license")
  public License getLicense() {
    return license;
  }

  public void setLicense(License license) {
    this.license = license;
  }

  public ProjectArticle embargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
    return this;
  }

   /**
   * Title for embargo
   * @return embargoTitle
  **/
  @ApiModelProperty(example = "File(s) under embargo", required = true, value = "Title for embargo")
  public String getEmbargoTitle() {
    return embargoTitle;
  }

  public void setEmbargoTitle(String embargoTitle) {
    this.embargoTitle = embargoTitle;
  }

  public ProjectArticle embargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
    return this;
  }

   /**
   * Reason for embargo
   * @return embargoReason
  **/
  @ApiModelProperty(example = "not complete", required = true, value = "Reason for embargo")
  public String getEmbargoReason() {
    return embargoReason;
  }

  public void setEmbargoReason(String embargoReason) {
    this.embargoReason = embargoReason;
  }

  public ProjectArticle references(List<String> references) {
    this.references = references;
    return this;
  }

  public ProjectArticle addReferencesItem(String referencesItem) {
    this.references.add(referencesItem);
    return this;
  }

   /**
   * List of references
   * @return references
  **/
  @ApiModelProperty(example = "[\"http://figshare.com\",\"http://figshare.com/api\"]", required = true, value = "List of references")
  public List<String> getReferences() {
    return references;
  }

  public void setReferences(List<String> references) {
    this.references = references;
  }

  public ProjectArticle relatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
    return this;
  }

  public ProjectArticle addRelatedMaterialsItem(RelatedMaterial relatedMaterialsItem) {
    if (this.relatedMaterials == null) {
      this.relatedMaterials = new ArrayList<RelatedMaterial>();
    }
    this.relatedMaterials.add(relatedMaterialsItem);
    return this;
  }

   /**
   * List of related materials; supersedes references and resource DOI/title.
   * @return relatedMaterials
  **/
  @ApiModelProperty(example = "[{\"id\":10432,\"identifier\":\"10.6084/m9.figshare.1407024\",\"identifier_type\":\"DOI\",\"relation\":\"IsSupplementTo\",\"title\":\"Figshare for institutions brochure\",\"is_linkout\":false}]", value = "List of related materials; supersedes references and resource DOI/title.")
  public List<RelatedMaterial> getRelatedMaterials() {
    return relatedMaterials;
  }

  public void setRelatedMaterials(List<RelatedMaterial> relatedMaterials) {
    this.relatedMaterials = relatedMaterials;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectArticle projectArticle = (ProjectArticle) o;
    return Objects.equals(this.id, projectArticle.id) &&
        Objects.equals(this.title, projectArticle.title) &&
        Objects.equals(this.doi, projectArticle.doi) &&
        Objects.equals(this.handle, projectArticle.handle) &&
        Objects.equals(this.url, projectArticle.url) &&
        Objects.equals(this.urlPublicHtml, projectArticle.urlPublicHtml) &&
        Objects.equals(this.urlPublicApi, projectArticle.urlPublicApi) &&
        Objects.equals(this.urlPrivateHtml, projectArticle.urlPrivateHtml) &&
        Objects.equals(this.urlPrivateApi, projectArticle.urlPrivateApi) &&
        Objects.equals(this.timeline, projectArticle.timeline) &&
        Objects.equals(this.thumb, projectArticle.thumb) &&
        Objects.equals(this.definedType, projectArticle.definedType) &&
        Objects.equals(this.definedTypeName, projectArticle.definedTypeName) &&
        Objects.equals(this.citation, projectArticle.citation) &&
        Objects.equals(this.confidentialReason, projectArticle.confidentialReason) &&
        Objects.equals(this.isConfidential, projectArticle.isConfidential) &&
        Objects.equals(this.size, projectArticle.size) &&
        Objects.equals(this.funding, projectArticle.funding) &&
        Objects.equals(this.fundingList, projectArticle.fundingList) &&
        Objects.equals(this.tags, projectArticle.tags) &&
        Objects.equals(this.version, projectArticle.version) &&
        Objects.equals(this.isActive, projectArticle.isActive) &&
        Objects.equals(this.isMetadataRecord, projectArticle.isMetadataRecord) &&
        Objects.equals(this.metadataReason, projectArticle.metadataReason) &&
        Objects.equals(this.status, projectArticle.status) &&
        Objects.equals(this.description, projectArticle.description) &&
        Objects.equals(this.isEmbargoed, projectArticle.isEmbargoed) &&
        Objects.equals(this.isPublic, projectArticle.isPublic) &&
        Objects.equals(this.createdDate, projectArticle.createdDate) &&
        Objects.equals(this.hasLinkedFile, projectArticle.hasLinkedFile) &&
        Objects.equals(this.categories, projectArticle.categories) &&
        Objects.equals(this.license, projectArticle.license) &&
        Objects.equals(this.embargoTitle, projectArticle.embargoTitle) &&
        Objects.equals(this.embargoReason, projectArticle.embargoReason) &&
        Objects.equals(this.references, projectArticle.references) &&
        Objects.equals(this.relatedMaterials, projectArticle.relatedMaterials) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, title, doi, handle, url, urlPublicHtml, urlPublicApi, urlPrivateHtml, urlPrivateApi, timeline, thumb, definedType, definedTypeName, citation, confidentialReason, isConfidential, size, funding, fundingList, tags, version, isActive, isMetadataRecord, metadataReason, status, description, isEmbargoed, isPublic, createdDate, hasLinkedFile, categories, license, embargoTitle, embargoReason, references, relatedMaterials, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectArticle {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    doi: ").append(toIndentedString(doi)).append("\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    urlPublicHtml: ").append(toIndentedString(urlPublicHtml)).append("\n");
    sb.append("    urlPublicApi: ").append(toIndentedString(urlPublicApi)).append("\n");
    sb.append("    urlPrivateHtml: ").append(toIndentedString(urlPrivateHtml)).append("\n");
    sb.append("    urlPrivateApi: ").append(toIndentedString(urlPrivateApi)).append("\n");
    sb.append("    timeline: ").append(toIndentedString(timeline)).append("\n");
    sb.append("    thumb: ").append(toIndentedString(thumb)).append("\n");
    sb.append("    definedType: ").append(toIndentedString(definedType)).append("\n");
    sb.append("    definedTypeName: ").append(toIndentedString(definedTypeName)).append("\n");
    sb.append("    citation: ").append(toIndentedString(citation)).append("\n");
    sb.append("    confidentialReason: ").append(toIndentedString(confidentialReason)).append("\n");
    sb.append("    isConfidential: ").append(toIndentedString(isConfidential)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    version: ").append(toIndentedString(version)).append("\n");
    sb.append("    isActive: ").append(toIndentedString(isActive)).append("\n");
    sb.append("    isMetadataRecord: ").append(toIndentedString(isMetadataRecord)).append("\n");
    sb.append("    metadataReason: ").append(toIndentedString(metadataReason)).append("\n");
    sb.append("    status: ").append(toIndentedString(status)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    isEmbargoed: ").append(toIndentedString(isEmbargoed)).append("\n");
    sb.append("    isPublic: ").append(toIndentedString(isPublic)).append("\n");
    sb.append("    createdDate: ").append(toIndentedString(createdDate)).append("\n");
    sb.append("    hasLinkedFile: ").append(toIndentedString(hasLinkedFile)).append("\n");
    sb.append("    categories: ").append(toIndentedString(categories)).append("\n");
    sb.append("    license: ").append(toIndentedString(license)).append("\n");
    sb.append("    embargoTitle: ").append(toIndentedString(embargoTitle)).append("\n");
    sb.append("    embargoReason: ").append(toIndentedString(embargoReason)).append("\n");
    sb.append("    references: ").append(toIndentedString(references)).append("\n");
    sb.append("    relatedMaterials: ").append(toIndentedString(relatedMaterials)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

