/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Collaborator;
import io.swagger.client.model.FundingInformation;
import io.swagger.client.model.Project;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ProjectComplete
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ProjectComplete extends Project {
  @SerializedName("url")
  private String url = null;

  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  @SerializedName("funding")
  private String funding = null;

  @SerializedName("funding_list")
  private List<FundingInformation> fundingList = new ArrayList<FundingInformation>();

  @SerializedName("description")
  private String description = null;

  @SerializedName("collaborators")
  private List<Collaborator> collaborators = new ArrayList<Collaborator>();

  public ProjectComplete url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint
   * @return url
  **/
  @ApiModelProperty(example = "http://api.figshare.com/v2/account/projects/1", required = true, value = "Api endpoint")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ProjectComplete id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Project id
   * @return id
  **/
  @ApiModelProperty(example = "1", required = true, value = "Project id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ProjectComplete title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Project title
   * @return title
  **/
  @ApiModelProperty(example = "project", required = true, value = "Project title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ProjectComplete funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Project funding
   * @return funding
  **/
  @ApiModelProperty(example = "", required = true, value = "Project funding")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ProjectComplete fundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ProjectComplete addFundingListItem(FundingInformation fundingListItem) {
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Full Project funding information
   * @return fundingList
  **/
  @ApiModelProperty(required = true, value = "Full Project funding information")
  public List<FundingInformation> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingInformation> fundingList) {
    this.fundingList = fundingList;
  }

  public ProjectComplete description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Project description
   * @return description
  **/
  @ApiModelProperty(example = "description", required = true, value = "Project description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ProjectComplete collaborators(List<Collaborator> collaborators) {
    this.collaborators = collaborators;
    return this;
  }

  public ProjectComplete addCollaboratorsItem(Collaborator collaboratorsItem) {
    this.collaborators.add(collaboratorsItem);
    return this;
  }

   /**
   * List of project collaborators
   * @return collaborators
  **/
  @ApiModelProperty(required = true, value = "List of project collaborators")
  public List<Collaborator> getCollaborators() {
    return collaborators;
  }

  public void setCollaborators(List<Collaborator> collaborators) {
    this.collaborators = collaborators;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectComplete projectComplete = (ProjectComplete) o;
    return Objects.equals(this.url, projectComplete.url) &&
        Objects.equals(this.id, projectComplete.id) &&
        Objects.equals(this.title, projectComplete.title) &&
        Objects.equals(this.funding, projectComplete.funding) &&
        Objects.equals(this.fundingList, projectComplete.fundingList) &&
        Objects.equals(this.description, projectComplete.description) &&
        Objects.equals(this.collaborators, projectComplete.collaborators) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(url, id, title, funding, fundingList, description, collaborators, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectComplete {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    collaborators: ").append(toIndentedString(collaborators)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

