/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.Project;
import java.io.IOException;

/**
 * ProjectPrivate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ProjectPrivate extends Project {
  @SerializedName("url")
  private String url = null;

  @SerializedName("id")
  private Long id = null;

  @SerializedName("title")
  private String title = null;

  /**
   * Role inside this project
   */
  @JsonAdapter(RoleEnum.Adapter.class)
  public enum RoleEnum {
    OWNER("Owner"),
    
    COLLABORATOR("Collaborator"),
    
    VIEWER("Viewer");

    private String value;

    RoleEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static RoleEnum fromValue(String text) {
      for (RoleEnum b : RoleEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<RoleEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final RoleEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public RoleEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return RoleEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("role")
  private RoleEnum role = null;

  /**
   * Project storage type
   */
  @JsonAdapter(StorageEnum.Adapter.class)
  public enum StorageEnum {
    INDIVIDUAL("individual"),
    
    GROUP("group");

    private String value;

    StorageEnum(String value) {
      this.value = value;
    }

    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }

    public static StorageEnum fromValue(String text) {
      for (StorageEnum b : StorageEnum.values()) {
        if (String.valueOf(b.value).equals(text)) {
          return b;
        }
      }
      return null;
    }

    public static class Adapter extends TypeAdapter<StorageEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final StorageEnum enumeration) throws IOException {
        jsonWriter.value(enumeration.getValue());
      }

      @Override
      public StorageEnum read(final JsonReader jsonReader) throws IOException {
        String value = jsonReader.nextString();
        return StorageEnum.fromValue(String.valueOf(value));
      }
    }
  }

  @SerializedName("storage")
  private StorageEnum storage = null;

  public ProjectPrivate url(String url) {
    this.url = url;
    return this;
  }

   /**
   * Api endpoint
   * @return url
  **/
  @ApiModelProperty(example = "http://api.figshare.com/v2/account/projects/1", required = true, value = "Api endpoint")
  public String getUrl() {
    return url;
  }

  public void setUrl(String url) {
    this.url = url;
  }

  public ProjectPrivate id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * Project id
   * @return id
  **/
  @ApiModelProperty(example = "1", required = true, value = "Project id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public ProjectPrivate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * Project title
   * @return title
  **/
  @ApiModelProperty(example = "project", required = true, value = "Project title")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ProjectPrivate role(RoleEnum role) {
    this.role = role;
    return this;
  }

   /**
   * Role inside this project
   * @return role
  **/
  @ApiModelProperty(example = "Owner", required = true, value = "Role inside this project")
  public RoleEnum getRole() {
    return role;
  }

  public void setRole(RoleEnum role) {
    this.role = role;
  }

  public ProjectPrivate storage(StorageEnum storage) {
    this.storage = storage;
    return this;
  }

   /**
   * Project storage type
   * @return storage
  **/
  @ApiModelProperty(example = "individual", required = true, value = "Project storage type")
  public StorageEnum getStorage() {
    return storage;
  }

  public void setStorage(StorageEnum storage) {
    this.storage = storage;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectPrivate projectPrivate = (ProjectPrivate) o;
    return Objects.equals(this.url, projectPrivate.url) &&
        Objects.equals(this.id, projectPrivate.id) &&
        Objects.equals(this.title, projectPrivate.title) &&
        Objects.equals(this.role, projectPrivate.role) &&
        Objects.equals(this.storage, projectPrivate.storage) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(url, id, title, role, storage, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectPrivate {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    url: ").append(toIndentedString(url)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    role: ").append(toIndentedString(role)).append("\n");
    sb.append("    storage: ").append(toIndentedString(storage)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

