/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.CustomArticleFieldAdd;
import io.swagger.client.model.FundingCreate;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ProjectUpdate
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class ProjectUpdate {
  @SerializedName("title")
  private String title = null;

  @SerializedName("description")
  private String description = null;

  @SerializedName("funding")
  private String funding = null;

  @SerializedName("funding_list")
  private List<FundingCreate> fundingList = null;

  @SerializedName("custom_fields")
  private Object customFields = null;

  @SerializedName("custom_fields_list")
  private List<CustomArticleFieldAdd> customFieldsList = null;

  public ProjectUpdate title(String title) {
    this.title = title;
    return this;
  }

   /**
   * The title for this project - mandatory. 3 - 1000 characters.
   * @return title
  **/
  @ApiModelProperty(example = "project title", value = "The title for this project - mandatory. 3 - 1000 characters.")
  public String getTitle() {
    return title;
  }

  public void setTitle(String title) {
    this.title = title;
  }

  public ProjectUpdate description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Project description
   * @return description
  **/
  @ApiModelProperty(example = "project description", value = "Project description")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ProjectUpdate funding(String funding) {
    this.funding = funding;
    return this;
  }

   /**
   * Grant number or organization(s) that funded this project. Up to 2000 characters permitted.
   * @return funding
  **/
  @ApiModelProperty(example = "", value = "Grant number or organization(s) that funded this project. Up to 2000 characters permitted.")
  public String getFunding() {
    return funding;
  }

  public void setFunding(String funding) {
    this.funding = funding;
  }

  public ProjectUpdate fundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
    return this;
  }

  public ProjectUpdate addFundingListItem(FundingCreate fundingListItem) {
    if (this.fundingList == null) {
      this.fundingList = new ArrayList<FundingCreate>();
    }
    this.fundingList.add(fundingListItem);
    return this;
  }

   /**
   * Funding creation / update items
   * @return fundingList
  **/
  @ApiModelProperty(value = "Funding creation / update items")
  public List<FundingCreate> getFundingList() {
    return fundingList;
  }

  public void setFundingList(List<FundingCreate> fundingList) {
    this.fundingList = fundingList;
  }

  public ProjectUpdate customFields(Object customFields) {
    this.customFields = customFields;
    return this;
  }

   /**
   * List of key, values pairs to be associated with the project
   * @return customFields
  **/
  @ApiModelProperty(example = "{\"defined_key\":\"value for it\"}", value = "List of key, values pairs to be associated with the project")
  public Object getCustomFields() {
    return customFields;
  }

  public void setCustomFields(Object customFields) {
    this.customFields = customFields;
  }

  public ProjectUpdate customFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
    return this;
  }

  public ProjectUpdate addCustomFieldsListItem(CustomArticleFieldAdd customFieldsListItem) {
    if (this.customFieldsList == null) {
      this.customFieldsList = new ArrayList<CustomArticleFieldAdd>();
    }
    this.customFieldsList.add(customFieldsListItem);
    return this;
  }

   /**
   * List of custom fields values, supersedes custom_fields parameter
   * @return customFieldsList
  **/
  @ApiModelProperty(value = "List of custom fields values, supersedes custom_fields parameter")
  public List<CustomArticleFieldAdd> getCustomFieldsList() {
    return customFieldsList;
  }

  public void setCustomFieldsList(List<CustomArticleFieldAdd> customFieldsList) {
    this.customFieldsList = customFieldsList;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ProjectUpdate projectUpdate = (ProjectUpdate) o;
    return Objects.equals(this.title, projectUpdate.title) &&
        Objects.equals(this.description, projectUpdate.description) &&
        Objects.equals(this.funding, projectUpdate.funding) &&
        Objects.equals(this.fundingList, projectUpdate.fundingList) &&
        Objects.equals(this.customFields, projectUpdate.customFields) &&
        Objects.equals(this.customFieldsList, projectUpdate.customFieldsList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(title, description, funding, fundingList, customFields, customFieldsList);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ProjectUpdate {\n");
    
    sb.append("    title: ").append(toIndentedString(title)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    funding: ").append(toIndentedString(funding)).append("\n");
    sb.append("    fundingList: ").append(toIndentedString(fundingList)).append("\n");
    sb.append("    customFields: ").append(toIndentedString(customFields)).append("\n");
    sb.append("    customFieldsList: ").append(toIndentedString(customFieldsList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

