/*
 * Figshare API
 * Figshare apiv2. Using Swagger 2.0
 *
 * OpenAPI spec version: 2.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;

/**
 * PublicFile
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2024-02-22T08:54:58.029Z")
public class PublicFile {
  @SerializedName("id")
  private Long id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("size")
  private Long size = null;

  @SerializedName("is_link_only")
  private Boolean isLinkOnly = null;

  @SerializedName("download_url")
  private String downloadUrl = null;

  @SerializedName("supplied_md5")
  private String suppliedMd5 = null;

  @SerializedName("computed_md5")
  private String computedMd5 = null;

  @SerializedName("mimetype")
  private String mimetype = null;

  public PublicFile id(Long id) {
    this.id = id;
    return this;
  }

   /**
   * File id
   * @return id
  **/
  @ApiModelProperty(example = "3000002", required = true, value = "File id")
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  public PublicFile name(String name) {
    this.name = name;
    return this;
  }

   /**
   * File name
   * @return name
  **/
  @ApiModelProperty(example = "test.xls", required = true, value = "File name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public PublicFile size(Long size) {
    this.size = size;
    return this;
  }

   /**
   * File size
   * @return size
  **/
  @ApiModelProperty(example = "14848", required = true, value = "File size")
  public Long getSize() {
    return size;
  }

  public void setSize(Long size) {
    this.size = size;
  }

  public PublicFile isLinkOnly(Boolean isLinkOnly) {
    this.isLinkOnly = isLinkOnly;
    return this;
  }

   /**
   * True if file is hosted somewhere else
   * @return isLinkOnly
  **/
  @ApiModelProperty(example = "false", required = true, value = "True if file is hosted somewhere else")
  public Boolean isIsLinkOnly() {
    return isLinkOnly;
  }

  public void setIsLinkOnly(Boolean isLinkOnly) {
    this.isLinkOnly = isLinkOnly;
  }

  public PublicFile downloadUrl(String downloadUrl) {
    this.downloadUrl = downloadUrl;
    return this;
  }

   /**
   * Url for file download
   * @return downloadUrl
  **/
  @ApiModelProperty(example = "https://ndownloader.figshare.com/files/3000002", required = true, value = "Url for file download")
  public String getDownloadUrl() {
    return downloadUrl;
  }

  public void setDownloadUrl(String downloadUrl) {
    this.downloadUrl = downloadUrl;
  }

  public PublicFile suppliedMd5(String suppliedMd5) {
    this.suppliedMd5 = suppliedMd5;
    return this;
  }

   /**
   * File supplied md5
   * @return suppliedMd5
  **/
  @ApiModelProperty(example = "043a51806d646e88cafbf19e7b82846f", required = true, value = "File supplied md5")
  public String getSuppliedMd5() {
    return suppliedMd5;
  }

  public void setSuppliedMd5(String suppliedMd5) {
    this.suppliedMd5 = suppliedMd5;
  }

  public PublicFile computedMd5(String computedMd5) {
    this.computedMd5 = computedMd5;
    return this;
  }

   /**
   * File computed md5
   * @return computedMd5
  **/
  @ApiModelProperty(example = "043a51806d646e88cafbf19e7b82846f", required = true, value = "File computed md5")
  public String getComputedMd5() {
    return computedMd5;
  }

  public void setComputedMd5(String computedMd5) {
    this.computedMd5 = computedMd5;
  }

  public PublicFile mimetype(String mimetype) {
    this.mimetype = mimetype;
    return this;
  }

   /**
   * MIME Type of the file, it defaults to an empty string
   * @return mimetype
  **/
  @ApiModelProperty(example = "application/pdf", value = "MIME Type of the file, it defaults to an empty string")
  public String getMimetype() {
    return mimetype;
  }

  public void setMimetype(String mimetype) {
    this.mimetype = mimetype;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    PublicFile publicFile = (PublicFile) o;
    return Objects.equals(this.id, publicFile.id) &&
        Objects.equals(this.name, publicFile.name) &&
        Objects.equals(this.size, publicFile.size) &&
        Objects.equals(this.isLinkOnly, publicFile.isLinkOnly) &&
        Objects.equals(this.downloadUrl, publicFile.downloadUrl) &&
        Objects.equals(this.suppliedMd5, publicFile.suppliedMd5) &&
        Objects.equals(this.computedMd5, publicFile.computedMd5) &&
        Objects.equals(this.mimetype, publicFile.mimetype);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, size, isLinkOnly, downloadUrl, suppliedMd5, computedMd5, mimetype);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class PublicFile {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    size: ").append(toIndentedString(size)).append("\n");
    sb.append("    isLinkOnly: ").append(toIndentedString(isLinkOnly)).append("\n");
    sb.append("    downloadUrl: ").append(toIndentedString(downloadUrl)).append("\n");
    sb.append("    suppliedMd5: ").append(toIndentedString(suppliedMd5)).append("\n");
    sb.append("    computedMd5: ").append(toIndentedString(computedMd5)).append("\n");
    sb.append("    mimetype: ").append(toIndentedString(mimetype)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

